/* $Header: /home/yav/catty/fkiss/RCS/extern.h,v 1.20 2000/10/17 05:00:17 yav Exp $
 * fkiss external functions
 * written by yav <yav@bigfoot.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifdef PUBLIC_FKISS_C
# define public
#else
# define public extern
#endif
public int change_setpal();
public void move_object_start();
public void move_object_end();
public int move_object2();
public void redraw_cells();
public char *ks_filename();
public int search_cell();
public void disp_info();
public FILE *ks_fopen();
public void set_transparency();
public void poor_system_pixels();
public void set_system_pixels();
public void parse_system_colors();
public void free_system_colors();
public int browse_document();
#undef public

#ifdef PUBLIC_SUB_C
# define public
#else
# define public extern
#endif
public char *ks_malloc();
public char *ks_realloc();
public char *ks_strdup();
public int ks_system2();
public void ks_system();
public char *get_directory();
public char *get_filename();
public int is_suffix();
public void cut_crlf();
public void kiss_exit();
public char *dos_filename();
public char *dos_pathname();
public int strcmp_dos_filename();
public void ks_srand();
public int ks_rand();
public void lstr_init();
public void lstr_ch();
public void lstr_cat();
public void lstr_bs();
#undef public

#ifdef PUBLIC_MESSAGE_C
# define public
#else
# define public extern
#endif
public void msg_init();
public int msg_queued();
#if NeedFunctionPrototypes
# if USE_STDARG
public void msgset(const char *, ...);
public void msg(const char *, ...);
public void debug_printf(const char *, ...);
# else
#  if USE_VARARGS
public void msgset();
public void msg();
public void debug_printf();
#  else
public void msgset();
public void msg();
public void debug_printf();
#  endif
# endif
#else /* NeedFunctionPrototypes */
# ifdef __STDC__
public void msgset(const char *, ...);
public void msg(const char *, ...);
public void debug_printf(const char *, ...);
# else /* __STDC__ */
public void msgset();
public void msg();
public void debug_printf();
# endif /* __STDC__ */
#endif /* NeedFunctionPrototypes */
#undef public

#ifdef PUBLIC_MENU_C
# define public
#else
# define public extern
#endif
#ifdef X_H
public int draw_string();
public void draw_menu_string();
public void change_menu_status();
public int calc_text_size();
public MW *alloc_mw();
public int which_winlist();
public void load_font();
public void expose_menu();
public void create_set_menu();
public void press_menu();
public void enter_menu();
public void leave_menu();
public void menu_setpal_change();
public Window aboutwin;
public void set_menu_window_attributes();
public void change_menu_func();
public void menu_resize();
public char *get_client_info();
public char *get_server_info();
public char *get_visual_info();
public char *get_cell_info();
#endif /* X_H */
#undef public

#ifdef PUBLIC_SELCNF_C
# define public
#else
# define public extern
#endif
public int is_regular_file();
public int select_menu();
public int select_cnf();
#undef public

#ifdef PUBLIC_KISSCNF_C
# define public
#else
# define public extern
#endif
public void init_object_cell();
public int read_config();
#undef public

#ifdef PUBLIC_KISSEVE_C
# define public
# define pubvar(type,name,init) type name = init;
#else
# define public extern
# define pubvar(type,name,init) extern type name;
#endif
public char *parse_string();
public void init_hitck();
public int cnf_event();
public int compile_event();
public int kissevent_initialize();
public int kissevent_handler2();
public int kissevent_handler();
public void kissevent_timer();
public int save_config();
public void init_redraw_area();
public int change_cel_mapping();
public void update_redraw_area();
public int get_sleep_time();

#define MAXSHORT ((short)(((unsigned short)~0)>>1))

/* global variables, set in "fkiss.c", used in "kisseve.c" */
pubvar( int,	WARN_ACTION,   256 );	/* warn if more actions per */
pubvar( int,	WARN_SOUNDFILE,256 );	/* warn if more soundfiles */
pubvar( int,	WARN_TIMER,    256 );	/* warn if more timer channels */
pubvar( int,	WARN_EVENT,    256 );	/* warn if more events   */
pubvar( int,	MAXACTION,     256 );	/* maximum action per event */
pubvar( int,	MAXEVENT,      256 );	/* maximum event number  */
pubvar( int,	MAXSOUNDFILE,  256 );	/* maximum sound file */
pubvar( int,	MAXTIMER,      256 );	/* maximum timer channel */
pubvar( int,	warncase,	 1 );	/* warn if upper case filename */
#undef public
#undef pubvar

#ifdef PUBLIC_COMMENT_C
# define public
#else
# define public extern
#endif
public void expose_comment();
public void unmap_comment();
public void map_comment();
#undef public

#ifdef PUBLIC_BG_C
# define public
#else
# define public extern
#endif
public void setup_signal_handler();
public int bg_shell();
public void bg_exit();
public int bg_play();
public int background();
#undef public

#ifdef PUBLIC_CURSOR_C
# define public
#else
# define public extern
#endif
public void init_cursor();
public void cursor_set();
public void cursor_grip();
public void cursor_hand();
public void cursor_scroll();
#undef public

#ifdef PUBLIC_COLOR_C
# define public
#else
# define public extern
#endif
public int read_colors();
public int alloc_colors();
public int set_private_colorcells();
#undef public

#ifdef PUBLIC_DIR_C
# define public
#else
# define public extern
#endif
public char **dir_ls();
public void dir_free();
#undef public

#ifdef PUBLIC_CODECONV_C
# define public
#else
# define public extern
#endif
public char *coding_name();
public int check_coding();
public void convert_coding();
#undef public

#ifdef PUBLIC_JISCODE_C
# define public
#else
# define public extern
#endif
public int is_sjis_1st();
public int is_sjis_2nd();
public unsigned short ysjis2jis();
public unsigned short yjis2sjis();
#undef public

#ifdef PUBLIC_SOUND_C
# define public
#else
# define public extern
#endif
public char *sound_device;
public int sound_debug;
public int use_esd;
public unsigned char *esd_host;
public int sound_init();
public void sound_end();
public int sound_play();
public int sound_cache();
public long sound_filesize();
#undef public

/* End of file */
